% Plotting geometries file; Author: Moges Retta, moges.retta@kuleuven.be
% This program plots the generated geometries and patchs them using the
% colors specified by r for red, g for green and m for magenta

load cord   %% coordinates of the vertexId for each of the tissues
load CellId %% contains the cellvertexId of each  
load PID    %% information about which cell is a palisade in each tissue
load EID    %% information about which cell is a epidermal cell in each tissue
load WALL   %% information about which vertices defines a wall
load W2C    %%

for i=1:length(CellId)  % For each geometry
 
 % Initialization   
 coordinates=[];
 CellvertexId=[];   
 epiId=[];          
 paliId=[];
 
 % Assign values to initialized vectors
 coordinates=cord{i}*0.8;
 CellvertexId=CellId{i};
 epiId=EID{i};
 paliId=PID{i};
 
%  subplot(length(CellId),1,i)  
figure(i)

 for j=1:length(CellvertexId)
    
        if ismember(j,epiId)
            patch(coordinates(CellvertexId{j},1),coordinates(CellvertexId{j},2),'r','linewidth',0.01)

        elseif ismember(j,paliId)
            patch(coordinates(CellvertexId{j}(:),1),coordinates(CellvertexId{j}(:),2),'m','linewidth',1)
        else

            patch(coordinates(CellvertexId{j},1),coordinates(CellvertexId{j},2),'g')
            hold on
        end
end
end

