function [ coordinates,dimension,numberofcells,walls,wall2cell,Wallbnd,l_n,Cellarea,CellvertexId,epiId,hypoId,paliId,stoneId,wallvepiuper,oldwall]=starttesselation(geom,numcell)

% Defining the size of the geometry and starting tesselations
close all
% geom=2
rand('state',geom);

% numcell=250;
x = 1*sqrt(100*numcell)*rand(numcell,1);
y = 1*sqrt(100*numcell)*rand(numcell,1);
centroids=[x,y];

% figure(1)
% voronoi(centroids(:,1),centroids(:,2))
% xmax=max(x);
% ymax=max(y);

xxmin=0; 
xxmax=1*sqrt(100*numcell);

centleaf=centroids(centroids(:,2)<0.7*mean(centroids(:,2)),:);
centroids=centleaf;
n=length(centroids);
Bc=zeros(n,2);

yymin=0;
yymax=max(centroids(:,2))+1;

%%
iteration=1;
%% iteration for generating the centroidal Voronoi cells

while sum(((centroids(:,1)-Bc(:,1)).*(centroids(:,1)-Bc(:,1)))/n)+sum(((centroids(:,2)-Bc(:,2)).*(centroids(:,2)-Bc(:,2)))/n)> 0.01

    BB=[centroids(:,1),centroids(:,2);-centroids(:,1),centroids(:,2)...
    ;centroids(:,1),-centroids(:,2);xxmax+(xxmax-centroids(:,1)),centroids(:,2)...
    ; centroids(:,1),yymax+(yymax-centroids(:,2))];

centroids2=[];
%  Voronoi diagram with centroids C and vertices V
[V,C]=voronoin(BB);

   for j=1:length(C)
 
        X = V(C{j},:);
        if ~isinf(X)
            % calculating  area and centroid of the voronoi region
            x0=mean(X(:,1));
            y0=mean(X(:,2));

            centroids2=[centroids2; x0 y0];

            % However, we are not interested in the centroids here any more;we use
            % random generators
            
        end
 
    end

%% selecting properties in the range of interest
B=centroids2;

% centroidal points in the region of interest
    
[Id,~]=nearestpoint(centroids(:,1),BB(:,1));
size(BB)
size(B)
B0=B(Id,1:2);

% area of voronoi regions of interest

    Bc=centroids;
    centroids= B0;
    clc
    iteration=iteration+1;
   
end
%%
Centroids=[centroids(:,1),centroids(:,2);xxmin-centroids(:,1),centroids(:,2)...
    ;centroids(:,1),yymin-centroids(:,2);xxmax+(xxmax-centroids(:,1)),centroids(:,2)...
    ; centroids(:,1),yymax+(yymax-centroids(:,2))];

%% constructing voronoi diagrams
[V,C]=voronoin(Centroids);
[~,~]=voronoi(Centroids(:,1),Centroids(:,2));

X1=[];

for j=1:length(C)
   if V(C{j},1)~=inf
        az=find(inpolygon(centroids(:,1),centroids(:,2),V(C{j},1),V(C{j},2))==1);

       if ~isempty(az)&V(C{j},1)~=inf       
         X =(V(C{j},:));
        if ~isinf(X)
        X=[[X(:,1) ; X(1,1)],[X(:,2) ; X(1,2)]];   
        end
        
        X1=[X1;X]; 
        V0{j}=X;
    
       end
   end
end
    

dis_x=[];
dis_y=[];
index=[];
index11=[];
COcel=[];

for i=1:length(V0)

    index1=[];
    coord_cell=V0{i};
    COcel=[COcel;coord_cell];
    
    for j=1:length(V0)
        if ~isequal(i,j)
            neighbor=intersect(coord_cell, V0{j},'rows');
            if ~isempty(neighbor)
                index1=[index1; i j];                        % pair of neighbor cells
                dis_x1= sqrt((centroids(i,1)-centroids(j,1))^2 );
                dis_y1=sqrt((centroids(i,2)-centroids(j,2))^2);
                dis_x=[dis_x;dis_x1];
                dis_y=[dis_y;dis_y1];
                index=[index; j];                            % neighbour cells to a given cell i
                index11=[index11;index1];
                NN{i}=index1;
            end
        end
    end
    
end

xk=COcel(10:length(COcel)-10,1);
yk=COcel(10:length(COcel)-10,2);

b=0.01;
a0=xk(:)<b+min(xk)==0;
xk(a0==0)=b+min(xk);
b0=xk(:)>-b+max(xk)==0;
xk(b0==0)=-b+max(xk);
c0=yk(:)<b+min(yk)==0;
yk(c0==0)=b+min(yk);
d0=yk(:)>-b+max(yk)==0;
yk(d0==0)=-b+max(yk);
k1=convhull(xk,yk);

AML=[];
for i=1:length(V0)
    [in , ~]=inpolygon(V0{i}(:,1),V0{i}(:,2),xk(k1),yk(k1));   
    if isempty(find(in==0, 1))
    AML=[AML;i];
    end
end
%% Identifying the hypodermis regions to avoid^pores in this region
hypoId=[];
  for i=1:length(V0)
      if max(V0{i}(:,2))>1.5*mean(COcel(:,2))
          hypoId=[hypoId,i];
      end
  end
  
  hypoId=[];
  %% making pores
poreId=[];
for i=1:length(AML)
   Ind1=[];
    for j=1:length(AML)
        
        if ~isequal(i,j)
            neb=intersect(V0{AML(i)},V0{AML(j)},'rows');
            if ~isempty(neb)
                Ind1=[Ind1;AML(i) AML(j)];
               
            end
        end
    end
    if (size(Ind1,1)<1|~ismember(Ind1,poreId))&~ismember(AML(i),hypoId)       
        poreId=[poreId;AML(i)];
    end
     
end

porId=[];

for i=1:length(poreId)      
    porId=[porId;poreId(i),NN{poreId(i)}(1,2)];       
end


for i=1:4:size(porId,1)
    if ismember(porId(i,2),AML)& ~ismember(NN{porId(i,1)}(:,2),poreId)     
    poreId=[poreId;porId(i,2)];   
    end
    
end

PP=[];
 
for i=1:length(poreId)
    abf=(V0{poreId(i)});
    if abs(min(abf(:,1))-min(COcel(:,1)))>40||abs(max(abf(:,1))-max(COcel(:,1)))>40
        PP=[PP;poreId(i)];
    end
end

poreId=PP;
%% making unique coordinates of the voronoi tesselation
[Id,~]=nearestpoint(centroids(:,1),Centroids(:,1));

for i=1:length(Id)
   
    counter=0;
    for k=1:length(V0)
        for h=1:length(V0{k})
             if ~ismember(k,poreId)
            counter=counter+1;
           
            cordinates(counter,1)=abs(V0{k}(h,1));
            cordinates(counter,2)=abs(V0{k}(h,2));
             end
           
        end
    
    end
end

[coordinates,~,J]=unique(cordinates,'rows');
Coordinates=coordinates;

%% updating the vornoi cell numbers as some of the voronoi cells are made pores
counter=0;
for k=1:length(V0)
       
   if ~ismember(k,poreId)
       counter=counter+1;
       V1{counter}=V0{k};           
   end
           
end

V0=V1;
  
    %% updating the hypodermal cell Id cell Id's are updated
    hypoId=[];
  for i=1:length(V0)
      if max(V0{i}(:,2))>1.5*mean(COcel(:,2))
          hypoId=[hypoId,i];
      end
  end
 
  hypoId=[];% if u are making cortex tissue

%% making wall vertices
counter=0;
for i=1:length(V0)
for j=1:length(V0{i})
counter=counter+1;
if j<length(V0{i})
Walls(counter,1)=J(counter);
Walls(counter,2)=J(counter+1);
end
end
end
for i=1:length(Walls)
for j=2:length(Walls)

    if Walls(j,1)==Walls(i,2)&&Walls(j,2)==Walls(i,1)
Walls(j,:)=0;
    end
end

end

[~,~,WAll1]=find(Walls(:,1));
[~,~,WAll2]=find(Walls(:,2));
Wall=[WAll1,WAll2];

Walls= unique(Wall,'rows');
for i=1:length(Walls)
    if ((abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1)))>abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2))))&&(coordinates(Walls(i,1),1))>coordinates(Walls(i,2),1))...
            ||((abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2)))>abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1))))&&(coordinates(Walls(i,1),2))>coordinates(Walls(i,2),2))
        wall(i,1)=Walls(i,2);
        wall(i,2)=Walls(i,1);
    else
        wall(i,1)=Walls(i,1);
        wall(i,2)=Walls(i,2);
    end
end

 walls=wall;

%% palisade cells
for i=1:length(walls)   
   l(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
end

ab_epi=mean(l);
epiuper=[];
for i=1:length(coordinates)
    if (abs(coordinates(i,2)-max(coordinates(:,2))))<0.01     
        epiuper=[epiuper,i];
    end
end

for i=1:length(epiuper)-1
    coordepiuper2(i,:)=[0.5*(coordinates(epiuper(i),1)+coordinates(epiuper(i+1),1)), coordinates(epiuper(i),2)];
end

coordepiuper2(length(coordepiuper2)+1,:)=[coordinates(epiuper(1),1), coordinates(epiuper(1),2)+ab_epi];
for i=1:length(epiuper)-1
   coordepiuper2(length(coordepiuper2)+1,:)=[coordepiuper2(i,1), coordepiuper2(i,2)+ab_epi];
end

coordepiuper2(length(coordepiuper2)+1,:)=[coordinates(epiuper(length(epiuper)),1),coordinates(epiuper(length(epiuper)),2)+ab_epi];
   
wallvepiuper(1,1)=epiuper(1);
for i=1:length(epiuper)-1 
   wallvepiuper(length(wallvepiuper)+1,1)=length(coordinates)+i;
end
   wallvepiuper(length(wallvepiuper)+1,1)=epiuper(length(epiuper));
   wallvepiuper(1,2)=length(coordinates)+length(epiuper);
   
for i=2:length(epiuper)
     wallvepiuper(i,2)=length(coordinates)+length(epiuper)+i-1;
end

wallvepiuper(length(wallvepiuper),2)=(length(coordinates)+2*(length(epiuper)));
  
for i=1:length(epiuper)-1
     wallHepiuper(i,1)=length(coordinates)+i;
     wallHepiuper(i,2)=epiuper(i+1);
     for j=1:length(walls)
         if ismember(walls(j,:),[epiuper(i),epiuper(i+1)])
             walls(j,2)=length(coordinates)+i;
         end
     end
     
end
   
for i=length(epiuper):length(coordepiuper2)-1
     wallHepiuper(i,1)=length(coordinates)+i;
     wallHepiuper(i,2)=length(coordinates)+i+1;
end
    
epiuperId{1}=[epiuper(1),length(coordinates)+1,length(coordinates)+length(epiuper)+1,length(coordinates)+length(epiuper),epiuper(1)];

for i=2:length(epiuper)-1 
   epiuperId{i}=[length(coordinates)+i-1,epiuper(i),length(coordinates)+i,length(coordinates)+length(epiuper)+i,...
   length(coordinates)+length(epiuper)+i-1,length(coordinates)+i];
end
 
 epiuperId{length(epiuperId)+1}=[length(coordinates)+i,epiuper(length(epiuper)),length(coordinates)+length(coordepiuper2),...
 length(coordinates)+length(coordepiuper2)-1,length(coordinates)+i];

abc1=abs(coordinates(:,1))<0.001;
abc2=abs(coordinates(:,2))<0.001;

coordinates(abc1,1)=0;
coordinates(abc2,2)=0;

 for i=1:length(V0)
     abv1=abs(V0{i}(:,1))<0.001;
      abv2=abs(V0{i}(:,2))<0.001;
      V0{i}(abv1,1)=0;
       V0{i}(abv2,2)=0;

       [~, ia, ib] = intersect(V0{i}(1:length(V0{i})-1,:), coordinates(epiuper,:),'rows');


    if length(ia)==2 && (min(ia)==1 && max(ia)~=length(V0{i})-1)
        V0{i}=[V0{i}(min(ia),:);coordepiuper2(min(ib),:);V0{i}(max(ia):length(V0{i}),:)];
    elseif length(ia)==2 && (min(ia)==1&&max(ia)==length(V0{i})-1)
        V0{i}=[V0{i}(1:length(V0{i})-1,:);coordepiuper2(min(ib),:);V0{i}(length(V0{i}),:)];
    elseif length(ia)==2 && min(ia)~=1
        V0{i}=[V0{i}(min(ia),:);coordepiuper2(min(ib),:);V0{i}(max(ia):length(V0{i})-1,:);V0{i}(1:min(ia),:)];
    end

 end

epiuper2=[];

for i=length(epiuper):length(coordepiuper2)
    if (abs(coordepiuper2(i,2)-max(coordepiuper2(:,2))))<0.01
        
        epiuper2=[epiuper2,length(coordinates)+i];
    end
end

for i=length(epiuper):length(coordepiuper2)-1
    coordepiuper22(i-length(epiuper)+1,:)=[0.5*(coordepiuper2(i,1)+coordepiuper2(i+1,1)), coordepiuper2(i,2)];
end

coordepiuper22(length(coordepiuper22)+1,:)=[coordepiuper2(length(epiuper),1), coordepiuper2(length(epiuper),2)+ab_epi];

for i=1:length(epiuper2)-1
   coordepiuper22(length(coordepiuper22)+1,:)=[coordepiuper22(i,1), coordepiuper22(i,2)+ab_epi];
end 

coordepiuper22(length(coordepiuper22)+1,:)=[coordepiuper2(length(coordepiuper2),1),coordepiuper2(length(coordepiuper2),2)+ab_epi];
wallvepiuper2(1,1)=epiuper2(1);
wallvepiuper2(1,2)=length(coordinates)+length(coordepiuper2)+length(epiuper2);

for i=1:length(epiuper2)-1
     wallvepiuper2(i+1,1)=length(coordinates)+2*(length(epiuper2)-1)+i;
     wallvepiuper2(i+1,2)=length(coordinates)+2*(length(epiuper2)-1)+i+length(epiuper2);
end

 wallvepiuper2(length(wallvepiuper2)+1,1)=epiuper2(length(epiuper2));
 wallvepiuper2(length(wallvepiuper2),2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22);
   
for i=1:length(epiuper2)-1
     wallHepiuper2(i,1)=length(coordinates)+length(coordepiuper2)+i;
     wallHepiuper2(i,2)=epiuper2(i+1);
     
   for j=1:length(wallHepiuper)
         if ismember(wallHepiuper(j,:),[epiuper2(i),epiuper2(i+1)])
             wallHepiuper(j,2)=length(coordinates)+length(coordepiuper2)+i;
         end
   end
 end
   
for i=length(epiuper2):length(coordepiuper22)-1
     wallHepiuper2(i,1)=length(coordinates)+length(coordepiuper2)+i;
     wallHepiuper2(i,2)=length(coordinates)+length(coordepiuper2)+i+1;
end

epiuperId2{1}=[epiuper2(1),length(coordinates)+length(coordepiuper2)+1,length(coordinates)+length(coordepiuper2)+length(epiuper2)+1,...
length(coordinates)+length(coordepiuper2)+length(epiuper2),epiuper2(1)];
  
for i=2:length(epiuper2)-1      
      epiuperId2{i}=[length(coordinates)+length(coordepiuper2)+i-1,epiuper2(i),length(coordinates)+length(coordepiuper2)+i,...
      length(coordinates)+length(coordepiuper2)+length(epiuper2)+i,length(coordinates)+length(coordepiuper2)+length(epiuper2)+i-1,...
      length(coordinates)+length(coordepiuper2)+i-1];
end

 
epiuperId2{length(epiuperId)+1}=[length(coordinates)+length(coordepiuper2)+i,epiuper2(length(epiuper2)),length(coordinates)+length(coordepiuper2)+length(coordepiuper22),...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)-1,length(coordinates)+length(coordepiuper2)+i];
  
for i=1:length(epiuperId)
    epiupercellveretex=[];
    epiupercellveretex=epiuperId{i};
    [c]= find(ismember(epiupercellveretex(1,1:length(epiupercellveretex(1,:))-1),epiuper2));
    epiuperId{i}=[epiupercellveretex(1,1:c(1)),length(coordinates)+length(coordepiuper2)+i,epiupercellveretex(1,c(2)),epiupercellveretex(1,1)];
 end

epilower=[];

for i=1:length(coordinates)
    if (abs(coordinates(i,2)-min(coordinates(:,2))))<0.01        
        epilower=[epilower,i];
    end
end

for i=1:length(epilower)-1
      coordepilower2(i,:)=[0.5*(coordinates(epilower(i),1)+coordinates(epilower(i+1),1)), coordinates(epilower(i),2)];
end

coordepilower2(length(coordepilower2)+1,:)=[coordinates(epilower(1),1), coordinates(epilower(1),2)-ab_epi];

for i=1:length(epilower)-1
   coordepilower2(length(coordepilower2)+1,:)=[coordepilower2(i,1), coordepilower2(i,2)-ab_epi];
end

coordepilower2(length(coordepilower2)+1,:)=[coordinates(epilower(length(epilower)),1),coordinates(epilower(length(epilower)),2)-ab_epi]; 
wallvepilower(1,1)=epilower(1);
for i=1:length(epilower)-1 
   wallvepilower(length(wallvepilower)+1,1)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i;
end

wallvepilower(length(wallvepilower)+1,1)=epilower(length(epilower));
wallvepilower(1,2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower);
   
for i=2:length(epilower)
     wallvepilower(i,2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+i-1;
end
wallvepilower(length(wallvepilower),2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+2*(length(epilower));
  
for i=1:length(epilower)-1
     wallHepilower(i,1)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i;
     wallHepilower(i,2)=epilower(i+1);
     for j=1:length(walls)
         if ismember(walls(j,:),[epilower(i),epilower(i+1)])
             walls(j,2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i;
         end
     end
     
end
   
for i=length(epilower):length(coordepilower2)-1
     wallHepilower(i,1)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i;
     wallHepilower(i,2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i+1;
end
epilowerId{1}=[epilower(1),length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower),...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+1,length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+1,...
epilower(1)];

for i=2:length(epilower)-1
      
epilowerId{i}=[length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i-1,length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+i-1,...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+i,...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i,epilower(i)...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i-1];
end

epilowerId{length(epilowerId)+1}=[length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i,...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+i,...
length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(epilower)+i+1,...
epilower(length(epilower)),length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+i];
abc1=abs(coordinates(:,1))<0.001;
abc2=abs(coordinates(:,2))<0.001;
coordinates(abc1,1)=0;
coordinates(abc2,2)=0;

 for i=1:length(V0)
     abv1=abs(V0{i}(:,1))<0.001;
     abv2=abs(V0{i}(:,2))<0.001;
     V0{i}(abv1,1)=0;
     V0{i}(abv2,2)=0;
     [~, ia, ib] = intersect(V0{i}(1:length(V0{i})-1,:), coordinates(epilower,:),'rows');

    if length(ia)==2 && (min(ia)==1 && max(ia)~=length(V0{i})-1) 
    V0{i}=[V0{i}(min(ia),:);coordepilower2(min(ib),:);V0{i}(max(ia):length(V0{i}),:)];
    elseif length(ia)==2 & (min(ia)==1& max(ia)==length(V0{i})-1)
    V0{i}=[V0{i}(1:length(V0{i})-1,:);coordepilower2(min(ib),:);V0{i}(length(V0{i}),:)];
    elseif length(ia)==2 & min(ia)~=1
    V0{i}=[V0{i}(min(ia),:);coordepilower2(min(ib),:);V0{i}(max(ia):length(V0{i})-1,:);V0{i}(1:min(ia),:)];
    end
end

for i=1:length(epiuper2)
      coordepiuper222(i,:)=[0.5*(coordepiuper22(length(coordepiuper22)-length(epiuper2)+i-1,1)+coordepiuper22(length(coordepiuper22)-length(epiuper2)+i,1)),...
      coordepiuper22(length(coordepiuper22),2)];
      epiuperId2{i}=[epiuperId2{i}(1:length(epiuperId2{i})-2),length(coordinates)+length(coordepiuper2)+length(coordepilower2)+length(coordepiuper22)+i,...
      epiuperId2{i}(length(epiuperId2{i})-1),epiuperId2{i}(length(epiuperId2{i}))];
      abw1=wallHepiuper2(:,1)==length(coordinates)+length(coordepiuper2)+length(coordepiuper22)-length(epiuper2)+i-1&...
      wallHepiuper2(:,2)==length(coordinates)+length(coordepiuper2)+length(coordepiuper22)-length(epiuper2)+i;
      wallHepiuper2(abw1,2)=length(coordinates)+length(coordepiuper2)+length(coordepilower2)+length(coordepiuper22)+i;
      wallHepiuper2(length(wallHepiuper2)+1,:)=[length(coordinates)+length(coordepiuper2)+length(coordepilower2)+length(coordepiuper22)+i,...
      length(coordinates)+length(coordepiuper2)+length(coordepiuper22)-length(epiuper2)+i];
end
  
for i=1:length(epilower)
      coordepilower222(i,:)=[0.5*(coordepilower2(length(coordepilower2)-length(epilower)+i-1,1)+coordepilower2(length(coordepilower2)-length(epilower)+i,1)),...
      coordepilower2(length(coordepilower2),2)];
      epilowerId{i}=[epilowerId{i}(1:2),length(coordinates)+length(coordepiuper2)+length(coordepilower2)+length(coordepiuper22)+length(coordepiuper222)+i,...
      epilowerId{i}(3:length(epilowerId{i})-1),epilowerId{i}(1)];
      abw2=wallHepilower(:,1)==length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(coordepilower2)-length(epilower)+i-1&...
      wallHepilower(:,2)==length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(coordepilower2)-length(epilower)+i;
      wallHepilower(abw2,2)=length(coordinates)+length(coordepiuper2)+length(coordepiuper22)+length(coordepilower2)+length(coordepiuper222)+i;
      wallHepilower(length(wallHepilower)+1,:)=[epilowerId{i}(3),epilowerId{i}(4)];
end

epiId=[];
counter=0;
for i=1:length(epiuperId)
    counter=counter+1;
    epiId{counter}=epiuperId{i};
end

adf1=epiuperId2{1};
adf2=epiuperId2{2};
adf3=epiuperId2{length(epiuperId2)};
adf4=epiuperId2{length(epiuperId2)-1};
epiuperId2{2}=[adf1(1),adf1(length(adf1)-1),adf2(1:5),adf1(1)];
epiuperId2{length(epiuperId2)-1}=[adf3(2:3),adf4(1,[1,2,3,4,6]),adf4(1)];
for i=2:length(epiuperId2)-1
    counter=counter+1;
    epiId{counter}=epiuperId2{i};
end

for i=1:length(epilowerId)
    counter=counter+1;
    epiId{counter}=epilowerId{i};
end


wallHepi=[wallHepiuper;wallHepiuper2;wallHepilower];
wallvepi=[wallvepiuper;wallvepiuper2;wallvepilower];
coordepi2=[coordepiuper2;coordepiuper22;coordepilower2;coordepiuper222;coordepilower222];
pali_lim=[min(coordepiuper2(:,2)),max(coordepiuper2(:,2))];
epiup_lim=[min(coordepiuper22(:,2)),max(coordepiuper22(:,2))];
epilow_lim=[min(coordepilower2(:,2)),max(coordepilower2(:,2))]; 

%%updating the coordinates and the walls after making the epidermal cells

coordinates=[coordinates;coordepi2];
coordinates(epiuperId2{2}(7),:)=0.5*(coordinates(epiuperId2{1}(5),:)+coordinates(epiuperId2{2}(6),:));
coordinates(epiuperId2{length(epiuperId2)-1}(6),:)=0.5*(coordinates(epiuperId2{length(epiuperId2)-1}(7),:)+coordinates(epiuperId2{length(epiuperId2)}(3),:));
walls=[walls;wallvepi;wallHepi]; 
numberofcells=length(V0)+length(epiId)+1; % with out epidermal cells

% figure(7)
% hold on
% axis equal
% 
% for i=1:length(epiuperId2)
%     plot(coordinates(epiuperId2{i},1),coordinates(epiuperId2{i},2),'r')
% end
%   for i=1:length(coordinates)
%   text(coordinates(i,1),coordinates(i,2),[strcat(num2str(i))],'FontSize',10)
% end
  
%% cellvertexId specification before making the corner pores, 
abb=abs(coordinates(:,1))<0.00001;
abby=abs(coordinates(:,2))<0.00001;
coordinates(abb,1)=0;
coordinates(abby,2)=0;
for i=1:length(V0)
    abbv=abs(V0{i}(:,1))<0.00001;
    V0{i}(abbv,1)=0;
    abbvy=abs(V0{i}(:,2))<0.00001;
    V0{i}(abbvy,2)=0;
    
    for j=1:length(V0{i})-1  
    [~, ~, ib] = intersect(V0{i}(j,:), coordinates(:,:),'rows');
    CellvertexId{i}(j)=ib;
    end
    
    CellvertexId{i}(length(CellvertexId{i})+1)=CellvertexId{i}(1);
end


  CellvertexId=[CellvertexId,epiId];
  PID1=[];

  %%
PID=[];

for i=1:(length(CellvertexId)-length(epiId))
    if rem(i,3)==0
        PID=[PID,i];
    end
end

for i=1:length(CellvertexId)
    ab_mean(i,:)=mean(coordinates(CellvertexId{i},:));
end

PP=[];
for i=1:length(PID)
    abf=mean(coordinates(CellvertexId{PID(i)},:));
    if abs(abf(1)-min(ab_mean(:,1)))>20&&abs(abf(1)-max(ab_mean(:,1)))>20
        PP=[PP;PID(i)];
    end
end

PID=[PP;PID1'];
CID1=[];
counter=0;
for i=1:length(CellvertexId)
    c0=mean(coordinates(CellvertexId{i},:));
    if ~ismember(i,PID)
    counter=counter+1;
    CID1{counter}=CellvertexId{i};
    end
end

poreId=[poreId;PID];
PP=[];



CellvertexId=[];
CellvertexId=CID1;
numberofcells=length(CID1)+1;
%%
V0=[];

for i=1:length(CellvertexId)
  
    if CellvertexId{i}(1)~=CellvertexId{i}(length(CellvertexId{i}))
        CellvertexId{i}=[CellvertexId{i},CellvertexId{i}(1)];
    end
    
    V0{i}=coordinates(CellvertexId{i}(1:length(CellvertexId{i})),:);

end

cordinates=[];   
    
counter=0;
for k=1:length(V0)
        
    for h=1:length(V0{k})
        counter=counter+1;           
        cordinates(counter,1)=(V0{k}(h,1));
        cordinates(counter,2)=(V0{k}(h,2));                     
    end
    
end


[coordinates,~,~]=unique(cordinates,'rows');

CellvertexId=[];
for i=1:length(V0)   
    for j=1:length(V0{i})  
    [~, ~, ib] = intersect(V0{i}(j,:), coordinates(:,:),'rows');
    CellvertexId{i}(j)=ib;
    end
end
% figure(8)
% for i=1:length(CellvertexId)
%     plot(coordinates(CellvertexId{i},1),coordinates(CellvertexId{i},2))
%     hold on
% end
% for i=1:length(coordinates)
% text(coordinates(i,1),coordinates(i,2),[strcat(num2str(i))],'FontSize',10)
% end


%% making wall vertices

Walls=[];
counter=0;
for i=1:length(CellvertexId)
for j=1:length(CellvertexId{i})
counter=counter+1;
if j<length(CellvertexId{i})
Walls(counter,1)=CellvertexId{i}(j);
Walls(counter,2)=CellvertexId{i}(j+1);
end
end
end
for i=1:length(Walls)
for j=2:length(Walls)
    if Walls(j,1)==Walls(i,2)&&Walls(j,2)==Walls(i,1)
        Walls(j,:)=0;
    end
end

end

[~,~,WAll1]=find(Walls(:,1));
[~,~,WAll2]=find(Walls(:,2));
Wall=[WAll1,WAll2];
Walls= unique(Wall,'rows');
for i=1:length(Walls)
    if ((abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1)))>abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2))))&&(coordinates(Walls(i,1),1))>coordinates(Walls(i,2),1))...
            ||((abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2)))>abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1))))&&(coordinates(Walls(i,1),2))>coordinates(Walls(i,2),2))
        wall(i,1)=Walls(i,2);
        wall(i,2)=Walls(i,1);
    else
        wall(i,1)=Walls(i,1);
        wall(i,2)=Walls(i,2);
    end
end

walls=wall;
 
  %% wall2cell specification final
wall2cell=zeros(length(walls),2);
for i=1:length(walls)
    for j=1:length(CellvertexId)
    QQ1=intersect(coordinates(walls(i,1),:),coordinates(CellvertexId{j}(:),:),'rows');
    QQ2=intersect(coordinates(walls(i,2),:),coordinates(CellvertexId{j}(:),:),'rows');
    x0(j)=mean(coordinates(CellvertexId{j}(:),1));
    y0(j)=mean(coordinates(CellvertexId{j}(:),2));
    if (~isempty(QQ1)&&~isempty(QQ2))
       Wall_vector= [coordinates(walls(i,2),:)-coordinates(walls(i,1),:),0];
       CellPos_vector=[[x0(j),y0(j)]-coordinates(walls(i,1),:),0];
       angle=cross( Wall_vector,CellPos_vector);
       if angle(3)>0
           wall2cell(i,1)=j;
       elseif angle(3)<0
           wall2cell(i,2)=j;
       end
    end
    end
   
end


for i=1:length(wall2cell)
    if wall2cell(i,1)==0
        wall2cell(i,1)=numberofcells;
    end
    if wall2cell(i,2)==0
        wall2cell(i,2)=numberofcells;
    end 
end

Coordinates=coordinates;

oldwall=length(walls);
  %% wall2cell specification
  wall2cell=numberofcells*ones(length(walls),2);
for i=1:length(walls)
    ind=[];
    for j=1:length(CellvertexId)
        if ismember(walls(i,:),CellvertexId{j})
            ind=[ind,j];
        end
    end
    wall2cell(i,1:length(ind))=ind;
end

 ba=find( wall2cell(1:(length(walls)),1)==numberofcells| wall2cell(1:(length(walls)),2)==numberofcells);
   Wall2cell=wall2cell(ba,:);
   Wallbnd=walls(ba,:);
   stoneId=[];
  %% identfying vertices which are not vertices of external walls and walls to adjacent to pores
  CORDint= find(~ismember(1:length(coordinates),Wallbnd));
   

  %%
for i=1:length( CellvertexId)  
 Cellarea(i)=polyarea(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2));
end
%% making the corner pores
CellvertexID=CellvertexId;%CellvertexID is used to update the cell vertices while making the corner pores

for i=1:length(CellvertexId)
    CellvertexId{i}=CellvertexId{i}(1:length(CellvertexId{i})-1);
end  
  
randn('state',2)
coordinate=coordinates;%coordinate is used to update the coordintes of vertices while making the corner pores
wallp=walls;
cordpore=1:2:length(coordinates);
    
HID=[];
for i=1:length(hypoId)
    HID=[HID,CellvertexId{hypoId(i)}];
end
HID=unique(HID);

cordpore=cordpore(~ismember(cordpore,HID));
stonevertex=[];

for i=1:length(stoneId)
    stonevertex=[stonevertex,CellvertexId{stoneId(i)}];
end
  
CELID=CellvertexId;

for i=1:length(CellvertexId)
    CellvertexId{i}=unique(CellvertexId{i});
end
 
for k=1:length(CellvertexId)
    CellvertexId{k}=unique(CellvertexId{k});   
    centroid{k}=mean(coordinates(CellvertexId{k}(:),:));
    thetarad{k}=atan2((coordinates(CellvertexId{k}(:),2)-centroid{k}(2)),(coordinates(CellvertexId{k}(:),1)-centroid{k}(1)));
    
    thetaneg=find(thetarad{k}<0);
    thetarad{k}(thetaneg(:))=thetarad{k}(thetaneg(:))+2*pi;
    [~,I] = sort(thetarad{k});
    CelvertexId{k}=CellvertexId{k};
    CellvertexId{k}=CelvertexId{k}(I);
    CellvertexId{k}=CellvertexId{k}(:)';
     
    CellvertexId{k}=[CellvertexId{k}(:);CellvertexId{k}(1)];
    xx=coordinates(CellvertexId{k}(1:length(CellvertexId{k}(:))-1),1);
    yy=coordinates(CellvertexId{k}(1:length(CellvertexId{k}(:))-1),2);
    
    x2 = [xx(2:length(xx),1);xx(1,1)];
    y2 = [yy(2:length(yy),1);yy(1,1)];
    %% calculating second moments of inertia
    a = (1/2*sum(x2.*yy-xx.*y2));

    x0(k) = 1/6*sum((x2.*yy-xx.*y2).*(xx+x2))/a;
    y0(k) = 1/6*sum((x2.*yy-xx.*y2).*(yy+y2))/a;
 end 
 
  %% wall2cell specification final
wall2cell=zeros(length(walls),2);
for i=1:length(walls)
    for j=1:length(CellvertexId)
    QQ1=intersect(coordinates(walls(i,1),:),coordinates(CellvertexId{j}(:),:),'rows');
    QQ2=intersect(coordinates(walls(i,2),:),coordinates(CellvertexId{j}(:),:),'rows');
    if (~isempty(QQ1)&&~isempty(QQ2))
       Wall_vector= [coordinates(walls(i,2),:)-coordinates(walls(i,1),:),0];
       CellPos_vector=[[x0(j),y0(j)]-coordinates(walls(i,1),:),0];
       angle=cross( Wall_vector,CellPos_vector);
       if angle(3)>0
           wall2cell(i,1)=j;
       elseif angle(3)<0
           wall2cell(i,2)=j;
       end
    end
    end
    
end


for i=1:length(wall2cell)
    if wall2cell(i,1)==0
    wall2cell(i,1)=numberofcells;
    end
    if wall2cell(i,2)==0
    wall2cell(i,2)=numberofcells;
    end 
end
%%
ba=find( wall2cell(:,1)==numberofcells| wall2cell(:,2)==numberofcells);
Wall2cell=wall2cell(ba,:);
Wallbnd=walls(ba,:);
Wallbndf=[];
   
for i=1:length(Wallbnd)
 [in , ~]=inpolygon(coordinates(Wallbnd(i,:),1),coordinates(Wallbnd(i,:),2),xk(k1),yk(k1))  ; 
    if ~isempty(find(in==0, 1))
    Wallbndf=[Wallbndf,i];    
    end
end

Wallbnd=Wallbnd(Wallbndf,:);
dimension=2;
 
paliId=[];
epiId=[];
for i=1:length(CellvertexId)
      if mean(coordinates(CellvertexId{i},2))>pali_lim(1)&& mean(coordinates(CellvertexId{i},2))<pali_lim(2)
          paliId=[paliId;i];
      end
      if (mean(coordinates(CellvertexId{i},2))>epiup_lim(1)&& mean(coordinates(CellvertexId{i},2))<epiup_lim(2))...
              ||(mean(coordinates(CellvertexId{i},2))>epilow_lim(1)&& mean(coordinates(CellvertexId{i},2))<epilow_lim(2))
          epiId=[epiId;i];
      end
end

%%
V0=[];

for i=1:length(CellvertexId)
    
    if CellvertexId{i}(1)~=CellvertexId{i}(length(CellvertexId{i}))
        CellvertexId{i}=[CellvertexId{i};CellvertexId{i}(1)];
    end
    
V0{i}=coordinates(CellvertexId{i}(1:length(CellvertexId{i})),:);

end
cordinates=[];   
    
counter=0;
for k=1:length(V0)        
    for h=1:length(V0{k})   
         counter=counter+1; 
         cordinates(counter,1)=(V0{k}(h,1));
         cordinates(counter,2)=(V0{k}(h,2));          
    end 
end

[coordinates,~,~]=unique(cordinates,'rows');
CellvertexId=[];
for i=1:length(V0)  
    for j=1:length(V0{i})
    [~, ~, ib] = intersect(V0{i}(j,:), coordinates(:,:),'rows');
    CellvertexId{i}(j)=ib;
    end
end

%% making wall vertices

Walls=[];
counter=0;
for i=1:length(CellvertexId)
    for j=1:length(CellvertexId{i})
        counter=counter+1;
        if j<length(CellvertexId{i})
            Walls(counter,1)=CellvertexId{i}(j);
            Walls(counter,2)=CellvertexId{i}(j+1);
        end
    end
end

for i=1:length(Walls)
    for j=2:length(Walls)
        if Walls(j,1)==Walls(i,2)&&Walls(j,2)==Walls(i,1)
        Walls(j,:)=0;
        end
    end
end


[~,~,WAll1]=find(Walls(:,1));
[~,~,WAll2]=find(Walls(:,2));
Wall=[WAll1,WAll2];
Walls= unique(Wall,'rows');
for i=1:length(Walls)
    if ((abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1)))>abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2))))&&(coordinates(Walls(i,1),1))>coordinates(Walls(i,2),1))...
            ||((abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2)))>abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1))))&&(coordinates(Walls(i,1),2))>coordinates(Walls(i,2),2))
        wall(i,1)=Walls(i,2);
        wall(i,2)=Walls(i,1);
    else
        wall(i,1)=Walls(i,1);
        wall(i,2)=Walls(i,2);
    end
end

walls=wall;
 
  %% wall2cell specification final
wall2cell=zeros(length(walls),2);
for i=1:length(walls)
    for j=1:length(CellvertexId)
    QQ1=intersect(coordinates(walls(i,1),:),coordinates(CellvertexId{j}(:),:),'rows');
    QQ2=intersect(coordinates(walls(i,2),:),coordinates(CellvertexId{j}(:),:),'rows');
    if (~isempty(QQ1)&&~isempty(QQ2))
       Wall_vector= [coordinates(walls(i,2),:)-coordinates(walls(i,1),:),0];
       CellPos_vector=[[x0(j),y0(j)]-coordinates(walls(i,1),:),0];
       angle=cross( Wall_vector,CellPos_vector);
       if angle(3)>0
           wall2cell(i,1)=j;
       elseif angle(3)<0
           wall2cell(i,2)=j;
       end
    end
    end   
end


for i=1:length(wall2cell)
   if wall2cell(i,1)==0
     wall2cell(i,1)=numberofcells;
   end
    if wall2cell(i,2)==0
     wall2cell(i,2)=numberofcells;
    end
end

wal=walls;
w2cell=wall2cell;
cord=coordinates;

walls=wal;
wall2cell=w2cell;
coordinates=cord;
l_n=[];
l=[];

for i=1:length(walls)
  l_n(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);      
  l(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
end
 
l_n=l_n';
l=l';

 
h=figure(34);
hold on
for i=1:length(CellvertexId)
    if ismember(i,[epiId])
plot(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2),'r');
  %text(mean(coordinates(CellvertexId{i}(:),1)),mean(coordinates(CellvertexId{i}(:),2)),[strcat('c_',num2str(i))],'FontSize',10)
    elseif ismember(i,[paliId])
        plot(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2),'m');

    else
       patch(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2),'g');
 
    end
hold on
axis('equal')
    
end